searchData={"items":[{"type":"module","title":"Flamel","doc":"Documentation for `Flamel`.","ref":"Flamel.html"},{"type":"function","title":"Flamel.blank?/1","doc":"Checks if something is blank?","ref":"Flamel.html#blank?/1"},{"type":"function","title":"Examples - Flamel.blank?/1","doc":"iex> Flamel.blank?(nil)\n    true\n\n    iex> Flamel.blank?(\"hello world\")\n    false\n\n    iex> Flamel.blank?(%{})\n    true\n\n    iex> Flamel.blank?(%{active: true})\n    false\n\n    iex> Flamel.blank?([])\n    true\n\n    iex> Flamel.blank?([\"one\"])\n    false\n\n    iex> Flamel.blank?(\"   \t   \")\n    true\n\n    iex> Flamel.blank?(0)\n    false\n\n    iex> Flamel.blank?(1)\n    false","ref":"Flamel.html#blank?/1-examples"},{"type":"function","title":"Flamel.boolean?/1","doc":"Is something a boolean?","ref":"Flamel.html#boolean?/1"},{"type":"function","title":"Examples - Flamel.boolean?/1","doc":"iex> Flamel.boolean?(true)\n    true\n\n    iex> Flamel.boolean?(false)\n    true\n\n    iex> Flamel.boolean?(nil)\n    false\n\n    iex> Flamel.boolean?(\"true\")\n    false","ref":"Flamel.html#boolean?/1-examples"},{"type":"function","title":"Flamel.present?/1","doc":"Checks if something is present?","ref":"Flamel.html#present?/1"},{"type":"function","title":"Examples - Flamel.present?/1","doc":"iex> Flamel.present?(nil)\n    false\n\n    iex> Flamel.present?(\"hello world\")\n    true\n\n    iex> Flamel.present?(%{})\n    false\n\n    iex> Flamel.present?(%{active: true})\n    true\n\n    iex> Flamel.present?([])\n    false\n\n    iex> Flamel.present?([\"one\"])\n    true\n\n    iex> Flamel.present?(\"   \t   \")\n    false\n\n    iex> Flamel.present?(0)\n    true\n\n    iex> Flamel.present?(1)\n    true","ref":"Flamel.html#present?/1-examples"},{"type":"function","title":"Flamel.to_atom/1","doc":"Converts to an atom. Warning: This uses `String.to_atom`","ref":"Flamel.html#to_atom/1"},{"type":"function","title":"Examples - Flamel.to_atom/1","doc":"iex> Flamel.to_atom(:test)\n    :test\n\n    iex> Flamel.to_atom(\"test\")\n    :test\n\n    iex> Flamel.to_atom(1)\n    :\"1\"\n\n    iex> Flamel.to_atom(1.1)\n    :\"1.1\"","ref":"Flamel.html#to_atom/1-examples"},{"type":"function","title":"Flamel.to_boolean/1","doc":"Convert something to a boolean","ref":"Flamel.html#to_boolean/1"},{"type":"function","title":"Examples - Flamel.to_boolean/1","doc":"iex> Flamel.to_boolean(\"Y\")\n    true\n\n    iex> Flamel.to_boolean(\"y\")\n    true\n\n    iex> Flamel.to_boolean(\"YES\")\n    true\n\n    iex> Flamel.to_boolean(\"Yes\")\n    true\n\n    iex> Flamel.to_boolean(\"yes\")\n    true\n\n    iex> Flamel.to_boolean(\"true\")\n    true\n\n    iex> Flamel.to_boolean(1)\n    true\n\n    iex> Flamel.to_boolean(true)\n    true \n\n    iex> Flamel.to_boolean(\"N\")\n    false\n\n    iex> Flamel.to_boolean(\"n\")\n    false\n\n    iex> Flamel.to_boolean(\"NO\")\n    false\n\n    iex> Flamel.to_boolean(\"No\")\n    false\n\n    iex> Flamel.to_boolean(\"no\")\n    false\n\n    iex> Flamel.to_boolean(\"false\")\n    false\n\n    iex> Flamel.to_boolean(0)\n    false\n\n    iex> Flamel.to_boolean(false)\n    false","ref":"Flamel.html#to_boolean/1-examples"},{"type":"function","title":"Flamel.to_date/1","doc":"Converts to a Date","ref":"Flamel.html#to_date/1"},{"type":"function","title":"Examples - Flamel.to_date/1","doc":"iex> Flamel.to_date(~D[2000-10-31])\n    ~D[2000-10-31]\n\n    iex> Flamel.to_date(%{\"day\" => \"01\", \"month\" => \"12\", \"year\" => \"2004\"})\n    ~D[2004-12-01]\n\n    iex> Flamel.to_date(\"2000-10-31\")\n    ~D[2000-10-31]\n\n    iex> Flamel.to_date(\"2000-31-12\")\n    nil\n\n    iex> Flamel.to_date(nil)\n    nil","ref":"Flamel.html#to_date/1-examples"},{"type":"function","title":"Flamel.to_datetime/1","doc":"Converts to a DateTime","ref":"Flamel.html#to_datetime/1"},{"type":"function","title":"Examples - Flamel.to_datetime/1","doc":"iex> Flamel.to_datetime(\"2000-10-31T01:30:00.000-05:00\")\n    ~U[2000-10-31 06:30:00.000Z]\n\n    iex> Flamel.to_datetime(~N[2019-10-31 23:00:07])\n    ~N[2019-10-31 23:00:07]\n\n    iex> {:ok, datetime} = DateTime.new(~D[2016-05-24], ~T[13:26:08.003], \"Etc/UTC\")\n    iex> Flamel.to_datetime(datetime)\n    ~U[2016-05-24 13:26:08.003Z]      \n\n    iex> Flamel.to_datetime(nil)\n    nil\n\n    iex> Flamel.to_datetime(\"badstring\")\n    nil","ref":"Flamel.html#to_datetime/1-examples"},{"type":"function","title":"Flamel.to_float/1","doc":"Converts to a float","ref":"Flamel.html#to_float/1"},{"type":"function","title":"Examples - Flamel.to_float/1","doc":"iex> Flamel.to_float(\"1.2\")\n    1.2\n\n    iex> Flamel.to_float(1.2)\n    1.2\n\n    iex> Flamel.to_float(1)\n    1.0\n\n    iex> Flamel.to_float(nil)\n    0.0","ref":"Flamel.html#to_float/1-examples"},{"type":"function","title":"Flamel.to_integer/1","doc":"Converts to an integer","ref":"Flamel.html#to_integer/1"},{"type":"function","title":"Examples - Flamel.to_integer/1","doc":"iex> Flamel.to_integer(\"1\")\n    1\n\n    iex> Flamel.to_integer(1)\n    1\n\n    iex> Flamel.to_integer(1.2)\n    1\n\n    iex> Flamel.to_integer(nil)\n    0","ref":"Flamel.html#to_integer/1-examples"},{"type":"function","title":"Flamel.to_iso8601/1","doc":"Converts to a DateTime","ref":"Flamel.html#to_iso8601/1"},{"type":"function","title":"Examples - Flamel.to_iso8601/1","doc":"iex> Flamel.to_iso8601(~U[2000-10-31 06:30:00.000Z])\n    \"2000-10-31T06:30:00.000Z\"\n\n    iex> Flamel.to_iso8601(~N[2019-10-31 23:00:07])\n    \"2019-10-31T23:00:07\"\n\n    iex> Flamel.to_iso8601(~D[2019-10-31])\n    \"2019-10-31\"","ref":"Flamel.html#to_iso8601/1-examples"},{"type":"function","title":"Flamel.to_map/1","doc":"Converts to a map","ref":"Flamel.html#to_map/1"},{"type":"function","title":"Flamel.to_string/1","doc":"Converts to a string","ref":"Flamel.html#to_string/1"},{"type":"function","title":"Examples - Flamel.to_string/1","doc":"iex> Flamel.to_string(nil)\n    \"\"\n\n    iex> Flamel.to_string(\"test\")\n    \"test\"\n\n    iex> Flamel.to_string(:test)\n    \"test\"\n\n    iex> Flamel.to_string(2.3)\n    \"2.3\"\n\n    iex> Flamel.to_string(1)\n    \"1\"\n\n    iex> Flamel.to_string(1)\n    \"1\"","ref":"Flamel.html#to_string/1-examples"},{"type":"function","title":"Flamel.try_and_return/2","doc":"Turn an exception into an error tuple. This can be used with `with` to\ncatch exceptions and turn them into error tuples.","ref":"Flamel.html#try_and_return/2"},{"type":"function","title":"Examples - Flamel.try_and_return/2","doc":"iex> Flamel.try_and_return(fn -> :ok end)\n    :ok\n\n    iex> Flamel.try_and_return(fn -> raise \"error\" end, {:ok, :default_value})\n    {:ok, :default_value}\n\n    iex> Flamel.try_and_return(fn -> raise \"error\" end)\n    {:error, \"error\"}","ref":"Flamel.html#try_and_return/2-examples"},{"type":"function","title":"Flamel.unwrap/1","doc":"Takes an {:ok, value} or {:error, message} tuple and returns the value","ref":"Flamel.html#unwrap/1"},{"type":"function","title":"Examples - Flamel.unwrap/1","doc":"iex> Flamel.unwrap({:ok, []})\n    []\n\n    iex> Flamel.unwrap({:error, \"message\"})\n    \"message\"","ref":"Flamel.html#unwrap/1-examples"},{"type":"function","title":"Flamel.unwrap_error!/1","doc":"Takes an {:ok, value} tuple and returns the value","ref":"Flamel.html#unwrap_error!/1"},{"type":"function","title":"Examples - Flamel.unwrap_error!/1","doc":"iex> Flamel.unwrap_error!({:ok, []})\n    ** (ArgumentError) {:ok, []} is not an :error tuple\n\n    iex> Flamel.unwrap_error!({:error, \"message\"})\n    \"message\"","ref":"Flamel.html#unwrap_error!/1-examples"},{"type":"function","title":"Flamel.unwrap_error_or_nil/1","doc":"Takes an {:error, value} tuple and returns the value or nil","ref":"Flamel.html#unwrap_error_or_nil/1"},{"type":"function","title":"Examples - Flamel.unwrap_error_or_nil/1","doc":"iex> Flamel.unwrap_error_or_nil({:ok, []})\n    nil\n\n    iex> Flamel.unwrap_error_or_nil({:error, \"message\"})\n    \"message\"","ref":"Flamel.html#unwrap_error_or_nil/1-examples"},{"type":"function","title":"Flamel.unwrap_ok!/1","doc":"Takes an {:ok, value} tuple and returns the value","ref":"Flamel.html#unwrap_ok!/1"},{"type":"function","title":"Examples - Flamel.unwrap_ok!/1","doc":"iex> Flamel.unwrap_ok!({:ok, []})\n    []\n\n    iex> Flamel.unwrap_ok!({:error, \"message\"})\n    ** (ArgumentError) {:error, \"message\"} is not an :ok tuple","ref":"Flamel.html#unwrap_ok!/1-examples"},{"type":"function","title":"Flamel.unwrap_ok_or_nil/1","doc":"Takes an {:ok, value} tuple and returns the value or nil","ref":"Flamel.html#unwrap_ok_or_nil/1"},{"type":"function","title":"Examples - Flamel.unwrap_ok_or_nil/1","doc":"iex> Flamel.unwrap_ok_or_nil({:ok, []})\n    []\n\n    iex> Flamel.unwrap_ok_or_nil({:error, \"message\"})\n    nil","ref":"Flamel.html#unwrap_ok_or_nil/1-examples"},{"type":"module","title":"Flamel.Map","doc":"A bunch of helper functions for Maps","ref":"Flamel.Map.html"},{"type":"function","title":"Flamel.Map.atomize_keys/1","doc":"Converts the top level keys in a map from string to atoms","ref":"Flamel.Map.html#atomize_keys/1"},{"type":"function","title":"Examples - Flamel.Map.atomize_keys/1","doc":"iex> Flamel.Map.atomize_keys(%{\"first_name\" => \"Thomas\", \"dob\" => \"07/01/1981\"})\n    %{first_name: \"Thomas\", dob: \"07/01/1981\"}\n\n    iex> Flamel.Map.atomize_keys(%{\"person\" => %{\"first_name\" => \"Thomas\", \"dob\" => \"07/01/1981\"}})\n    %{person: %{first_name: \"Thomas\", dob: \"07/01/1981\"}}\n\n    iex> Flamel.Map.atomize_keys(%{first_name: \"Thomas\", dob: \"07/01/1981\"})\n    %{first_name: \"Thomas\", dob: \"07/01/1981\"}","ref":"Flamel.Map.html#atomize_keys/1-examples"},{"type":"function","title":"Flamel.Map.indifferent_get/3","doc":"Get a value from a map whether the key is a string or atom\n\nExamples\n\niex> Flamel.Map.indifferent_get(%{test: \"value\"}, \"test\")\n\"value\"\n\niex> Flamel.Map.indifferent_get(%{test: \"value\"}, :test)\n\"value\"\n\niex> Flamel.Map.indifferent_get(%{\"test\" => \"value\"}, :test)\n\"value\"\n\niex> Flamel.Map.indifferent_get(%{\"test\" => \"value\"}, \"test\")\n\"value\"\n\niex> Flamel.Map.indifferent_get(%{\"test\" => \"value\"}, \"does-not-exist\", \"default\")\n\"default\"","ref":"Flamel.Map.html#indifferent_get/3"},{"type":"function","title":"Flamel.Map.safely_get/2","doc":"Safely get a value out of Map/Struct","ref":"Flamel.Map.html#safely_get/2"},{"type":"function","title":"Flamel.Map.safely_get/3","doc":"","ref":"Flamel.Map.html#safely_get/3"},{"type":"function","title":"Flamel.Map.stringify_keys/1","doc":"Converts the top level keys in a map from atoms to strings","ref":"Flamel.Map.html#stringify_keys/1"},{"type":"function","title":"Examples - Flamel.Map.stringify_keys/1","doc":"iex> Flamel.Map.stringify_keys(%{a: 1, b: 2})\n    %{\"a\" => 1, \"b\" => 2}\n\n    iex> Flamel.Map.stringify_keys(%{a: 1, b: 2, c: %{d: 3, e: 4}})\n    %{\"a\" => 1, \"b\" => 2, \"c\" => %{\"d\" => 3, \"e\" => 4}}\n\n    iex> Flamel.Map.stringify_keys(%{\"a\" => 1, \"b\" => 2})\n    %{\"a\" => 1, \"b\" => 2}","ref":"Flamel.Map.html#stringify_keys/1-examples"},{"type":"extras","title":"License","doc":"MIT License\n\nCopyright (c) 2023 Thomas Brewer\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"},{"type":"extras","title":"Readme","doc":"# Flamel\n\nThis package is a bag of helper functions. Some might be questionable but they are what they are so use them as you will.","ref":"readme.html"},{"type":"extras","title":"Installation - Readme","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `flamel` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:flamel, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Examples - Readme","doc":"```elixir\nFlamel.try_and_return(fn -> :ok end) == :ok\n\nFlamel.try_and_return(fn -> raise \"error\" end, {:ok, :default_value}) == {:ok, :default_value}\n\nFlamel.unwrap_ok!({:ok, []}) == []\n\nFlamel.blank?(%{}) == true\n\nFlamel.present?(%{}) == false\n\nFlamel.to_boolean(\"Y\") == true\n\nFlamel.to_datetime(\"2000-10-31T01:30:00.000-05:00\") == ~U[2000-10-31 06:30:00.000Z]\n\nFlamel.to_datetime(~N[2019-10-31 23:00:07]) == ~N[2019-10-31 23:00:07]\n\nFlamel.to_date(~D[2000-10-31]) == ~D[2000-10-31]\n\nFlamel.to_date(%{\"day\" => \"01\", \"month\" => \"12\", \"year\" => \"2004\"}) == ~D[2004-12-01]\n\nFlamel.to_date(\"2000-10-31\") == ~D[2000-10-31]\n\nFlamel.to_iso8601(~U[2000-10-31 06:30:00.000Z]) == \"2000-10-31T06:30:00.000Z\"\n\nFlamel.to_iso8601(~D[2019-10-31]) == \"2019-10-31\"\n```\n\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#examples"}],"content_type":"text/markdown"}